/**
 *
 * $Id: adapter.cpp,v 1.5 2008/05/13 17:30:03 mviara Exp $
 * $Author: mviara $
 * $Name:  $
 *
 * Adattatore video.
 * 
 * $Log: adapter.cpp,v $
 * Revision 1.5  2008/05/13 17:30:03  mviara
 *
 * First beta version for Linux system.
 *
 * Revision 1.4  2005/04/03 08:27:47  mviara
 * Added support for copy paste text.
 *
 * Revision 1.3  2005/04/02 07:26:29  mviara
 * Added partial support for copy/paste text.
 *
 * Revision 1.2  2005/03/28 12:53:09  mviara
 * Added support for xterm, fixed bug in attribute at begin of line.
 *
 * Revision 1.1.1.1  2004/07/10 12:33:21  mviara
 * Migrated from RCS
 *
 *
 * 
 */
#include "ansi.hpp"

static const char rcsinfo[]= "$Id: adapter.cpp,v 1.5 2008/05/13 17:30:03 mviara Exp $";

void CAdapter::Print(int pos,char *buffer)
{
	PrintBuffer(pos,buffer,strlen(buffer));
}


KSTATE CAdapter::GetState()
{
	return kstate;
}

void CAdapter::SetColor(unsigned col)
{
	curColor = col;
}

char * CAdapter::Name()
{
	return "Generic Adapter";
}


CAdapter::CAdapter()
{
	kstate.flags = 0;
	curColor = 0;
	SetColor(7);
}

void CAdapter::BigCursor()
{
}

void CAdapter::LittleCursor()
{
}



void CAdapter::PrintBuffer(int pos,char * buffer ,int len)
{
	int lastPos = 0;
	char c=(char)~*buffer;
	int num=0;

	while (len--)
	{
		if (c != *buffer)
		{
			if (num)
				Print(lastPos,c,num);
			c = *buffer;
			num = 1;
			lastPos = pos;
		}
		else
			num++;
		
		pos++;
		buffer++;
	}

	assert(num != 0);
	
	Print(lastPos,c,num);
}

void CAdapter::HideCursor()
{
}

void CAdapter::ShowCursor()
{
}
