/**
 *
 * $Id: screen.cpp,v 1.9 2008/05/13 21:22:59 mviara Exp $
 * $Author: mviara $
 * $Name:  $
 *
 * Gestione screen virtuali.
 * 
 * $Log: screen.cpp,v $
 * Revision 1.9  2008/05/13 21:22:59  mviara
 * Fixed several bugs in scroll up/down (Yast2 on suse 10.x)
 *
 * Revision 1.8  2008/05/13 17:30:03  mviara
 *
 * First beta version for Linux system.
 *
 * Revision 1.7  2005/04/19 14:05:37  mviara
 * Added supporto save restore attribute with ESC7 / ESC8
 *
 * Revision 1.6  2005/03/28 12:53:09  mviara
 * Added support for xterm, fixed bug in attributr at begin of line.
 *
 * Revision 1.5  2004/12/06 20:08:04  mviara
 * Default color green on black.
 *
 * Revision 1.4  2004/12/06 07:31:38  mviara
 * Bug fixed in ESC 1 K
 *
 * Revision 1.3  2004/11/30 20:06:41  mviara
 * Added support for hide/show cursor.
 * Set default to green on black.
 *
 * Revision 1.2  2004/07/10 13:59:12  mviara
 * Some minor changes.
 *
 * Revision 1.1.1.1  2004/07/10 12:33:22  mviara
 * Migrated from RCS
 *
 *
 * 
 */

#include "ansi.hpp"
static const char rcsinfo[]= "$Id: screen.cpp,v 1.9 2008/05/13 21:22:59 mviara Exp $";

	

void CAnsi::CScreen::Print(char chr,int num)
{
	SCHAR ch;
	
	ch.color = (unsigned char)curColor;
	ch.chr = chr;
	while (num--)
		buffer[curPos++] = ch;
	
}

CAnsi::CScreen::~CScreen()
{
	delete [] buffer;
	delete [] statusLine;
}


void CAnsi::CScreen::Default()
{
	DisplayChar  = &CAnsi::DisplayNormal;
        gvt100 = 0;
	autoWrap = 1;
	orMask = 0;
	bscroll = 0;
	escroll = numRow - 1;
	//cursorOn = 1;				// cursore attivo
	scrolloff = 0;				// scroll attivo
	
}

CAnsi::CScreen::CScreen(int row,int col)
{
	int i;

	statusLine = new char[col+1];
	buffer = new SCHAR[(row+1)*col];
	numRow = row;
	numCol = col;
	
	assert(buffer != 0);
	
	
	for (i = 0 ; i < FCNKEY ; i++)
		lenght[i] = 0;

	ps = pl = 0;
	attribute.fnormal = attribute.fcolor = attribute.breverse = 2;
	attribute.bcolor = attribute.bnormal = attribute.freverse = 0;
	attribute.reverse = attribute.hi = attribute.blink = 0;
	curColor = 0;
	cursorOn = 1;
	initialized = 0;
	Default();
}
